diff mbox series

generic: add a test for device removal with dirty data

Message ID 20230723045017.1706370-1-zlang@kernel.org (mailing list archive)
State New, archived
Headers show
Series generic: add a test for device removal with dirty data | expand

Commit Message

Zorro Lang July 23, 2023, 4:50 a.m. UTC
From: Christoph Hellwig <hch@lst.de>

Test the removal of the underlying device when the file system still
has dirty data.

Signed-off-by: Christoph Hellwig <hch@lst.de>
---

Hi Christoph,

I'd like to help this patchset to catch this or next fstests release. So I
changed this patch a bit, if you feel good, I'll merge this patch as below.
(Same to the 2nd patch).

Change logs:
1) Replace SCRATCH_DEV with TEST_DEV, replace SCRATCH_MNT with SCSI_DEBUG_MNT
   which is a directory in TEST_DIR, due to we don't call _require_scratch
   in this case.
2) Call _fail if _mkfs_dev or _mount fails

Thanks,
Zorro

 tests/generic/730     | 59 +++++++++++++++++++++++++++++++++++++++++++
 tests/generic/730.out |  2 ++
 2 files changed, 61 insertions(+)
 create mode 100755 tests/generic/730
 create mode 100644 tests/generic/730.out

Comments

Christoph Hellwig July 24, 2023, 1:32 p.m. UTC | #1
On Sun, Jul 23, 2023 at 12:50:17PM +0800, Zorro Lang wrote:
> I'd like to help this patchset to catch this or next fstests release. So I
> changed this patch a bit, if you feel good, I'll merge this patch as below.
> (Same to the 2nd patch).

I've actually got a few other changes locally nad plant to send it out.

> Change logs:
> 1) Replace SCRATCH_DEV with TEST_DEV, replace SCRATCH_MNT with SCSI_DEBUG_MNT
>    which is a directory in TEST_DIR, due to we don't call _require_scratch
>    in this case.

The SCSI_DEBUG_MNT change is fine.  The SCRATCH_DEV stuff I think we don't
need at all, after all the sector size doesn't really matter for this
test, so I've just dropped it.

> 2) Call _fail if _mkfs_dev or _mount fails

Shouldn't the mkfs side also use run_check ?

Btw, your cleanups should also go into generic/108 from where I took
the scsi_debug boilerplate.

I'll resend later today, also incorporating your changes.
diff mbox series

Patch

diff --git a/tests/generic/730 b/tests/generic/730
new file mode 100755
index 00000000..7886b38d
--- /dev/null
+++ b/tests/generic/730
@@ -0,0 +1,59 @@ 
+#! /bin/bash
+# SPDX-License-Identifier: GPL-2.0
+# Copyright (c) 2015 Red Hat Inc. All Rights Reserved.
+# Copyright (c) 2023 Christoph Hellwig
+#
+# Test proper file system shut down when the block device is removed underneath
+# and there is dirty data.
+#
+. ./common/preamble
+_begin_fstest auto quick
+
+_cleanup()
+{
+	cd /
+	$UMOUNT_PROG $SCSI_DEBUG_MNT >>$seqres.full 2>&1
+	_put_scsi_debug_dev
+	rm -r -f $tmp.*
+}
+
+. ./common/filter
+. ./common/scsi_debug
+
+_supported_fs generic
+
+# We don't actually use the test device, but we need a block based fs
+_require_test
+_require_block_device $TEST_DEV
+_require_scsi_debug
+
+physical=`blockdev --getpbsz $TEST_DEV`
+logical=`blockdev --getss $TEST_DEV`
+
+SCSI_DEBUG_DEV=`_get_scsi_debug_dev ${physical:-512} ${logical:-512} 0 300`
+test -b "$SCSI_DEBUG_DEV" || _notrun "Failed to initialize scsi debug device"
+echo "SCSI debug device $SCSI_DEBUG_DEV" >>$seqres.full
+
+_mkfs_dev $SCSI_DEBUG_DEV || _fail "make $FSTYP on $SCSI_DEBUG_DEV"
+SCSI_DEBUG_MNT="$TEST_DIR/scsi_debug_$seq"
+rm -rf $SCSI_DEBUG_MNT
+mkdir $SCSI_DEBUG_MNT
+run_check _mount $SCSI_DEBUG_DEV $SCSI_DEBUG_MNT
+
+# create a test file
+$XFS_IO_PROG -f -c "pwrite 0 1M" $SCSI_DEBUG_MNT/testfile >>$seqres.full
+
+# open a file descriptor for reading the file
+exec 3< $SCSI_DEBUG_MNT/testfile
+
+# delete the scsi debug device while it still has dirty data
+echo 1 > /sys/block/$(_short_dev $SCSI_DEBUG_DEV)/device/delete
+
+# try to read from the file, which should give us -EIO
+cat <&3 > /dev/null
+
+# close the file descriptor to not block unmount
+exec 3<&-
+
+status=0
+exit
diff --git a/tests/generic/730.out b/tests/generic/730.out
new file mode 100644
index 00000000..79e96db8
--- /dev/null
+++ b/tests/generic/730.out
@@ -0,0 +1,2 @@ 
+QA output created by 730
+cat: -: Input/output error